\section{GitOps}

GitOps is an approach to continuous delivery for infrastructure and workloads. It works by using a Git source as single source of truth. Per k8s, this means using pushes/pull requests instead of kubectl create/apply or helm install/upgrade”when ready to add/change spec. An additional pipeline builds the artefacts and promotes them to production. In GitOps pipeline model, ANY change to production must be made in source control prior to being applied to cluster.

\paragraph{Advantages}
\begin{description}
	\itemsep -0.2em
	\item [Declarative] app definitions, environments, and configurations 
	\item [Version-controlled] trackable, declarative, reviewable, etc. 
	\item [Automated] no human interaction required after spec 
	\item [Repeatable] same inputs result in same target state
	\item [Single source of truth] defining the application state
\end{description}

\subsection{K8s management with GitOps}
User supplies desired state via declaring it in manifests and/or interactive commands. Kubernetes works to balance the current state and the desired state.

\begin{itemize}
	\itemsep -0.2em
	\item Desired State - what you want your production environment to be in.
	\item Current State - current status of your production environment.
\end{itemize}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{k8gitops}
  \caption{K8s with GitOps}
\end{figure}

\paragraph{What do we need?}
\begin{itemize}
	\itemsep -0.2em
	\item A Git repository with your workloads definitions in YAML format, Helm charts and any other Kubernetes custom resource that defines your cluster desired state (config repository).
	\item A container registry where your CI system pushes immutable images (no latest tags, use semantic versioning or git commit sha)
	\item A controller, operator, or other process that runs in your cluster and does a two-way synchronization: watches the registry for new images releases, watches for change in the config repository and applied them to your cluster.
\end{itemize}

\subsection{ArgoCD}
Is a declarative GitOps tool used to deploy applications to K8s.

How it works:
\begin{itemize}
	\itemsep -0.2em
	\item Spins up its own controller in the cluster
	\item Watches for changes in the repository
	\item Compares against resources deployed in the cluster
	\item Synchronises the states
\end{itemize}

\begin{description}
	\itemsep -0.2em
	\item [App/Application]  group of K8s resources defined by a manifest - CRD 
	\item [Application source type] which build tool is used to build the app 
	\item [Live state] current state of application in the cluster
	\item [Target state] desired state of application in the cluster
	\item [Sync status] is the live state also the target state?
	\item [Sync] updating app to the target state
	\item [Sync operation status] success/failure of sync
	\item [Refresh] comparison of code in Git with the live state
	\item [Health] is the app running correctly and serving requests?
	\item [Configuration management tool] tool to create manifests from files in directory
	\item [Configuration management plugin] custom tool
\end{description}
 

